 #if !defined(__COMPACT__) && !defined(__LARGE__) && !defined(__HUGE__)
#error This program requires the use of far memory  models to work proprly
#endif

#define __EMS_FUNC_
#define   TRUE     1
#define   FALSE    0
#define   EMS_INT  0x67
#define  _16KPAGE  16384
#define  _49KPAGE  49152
#define  _em_CLASS
#include <stdlib.h>
#include <alloc.h>
#include <mem.h>
#include <dos.h>
#include "ems.h"

typedef void ( * FARFPTR )();            // function pointer type

FARFPTR  XMSHandler  = NULL ;            // pointer to Xms handler.
int      UMM_flag    = FALSE;            // if true, ok to use XMS
extern   FARFPTR   _new_handler;         // new memory handler
char                EMS_DRIVER_OK;
char                EMS_OK       ;
unsigned int        MAXEMSPAGES  ;
unsigned int        EMS_SEG;
void far *	    EMSBASEADDRESS;
EMS_Status          E_M_S_Status;
char             *  EMSDrvName = "EMMXXXX0"; /* EMS Driver name */

//***********************************************************************
//	Frees all EMS pages associated with a ems handle
int  AX_,BX_,CX_,DX_,ES_;
unsigned char AH_,BH_,CH_,DH_,AL_,BL_,CL_,DL_,flags;

void far freehandle(int Handle, int  *error )
{
   *error = TRUE;

   if (!EMS_DRIVER_OK) return;
   asm{
    mov ah,45h
    mov dx,Handle
    int EMS_INT
    mov AH_,AH
   }
  *error = AH_;
}

void far currentemsstatus(EMS_Status *EMMStatus ,int *error)
{
  *error = TRUE;
  if (!EMS_DRIVER_OK) return;

   //*****************************
   // Get number of handles open
   //****************************
       asm{
	mov AH, 4Bh
	int EMS_INT
	mov AH_,AH;
	mov BX_,BX
	}
	if (AH_!= 0)  return;
	EMMStatus->UsedHandles = BX_;
     //****************************
     // Get status Function
     //****************************
       asm{
	mov AH, 40h
	int EMS_INT
	mov AH_,AH
	}
	EMMStatus->EMS_StatusCode = AH_;
	*error  = AH_;
	if (AH_ != 0) return;
	EMS_OK = TRUE;
      //****************************
      // Get unused pages
      // Get Tot_AL Pages
      //****************************
       asm{
	mov AH, 42h
	int EMS_INT
	mov AH_,AH;
	mov BX_,BX
	mov DX_,DX
	}
	*error  = AH_;
	if (AH_!=0) return;
	EMMStatus->UnusedPages  = BX_;
	MAXEMSPAGES   =DX_;
}


// EmsDaraPtr returns a pointer which points to data  in the
// Physical page in the EMS page frame
void far * emsdataptr(int PhyPage,int Offset)
{
    if ((PhyPage < 4) && EMS_OK  )
    return( MK_FP(EMS_SEG, PhyPage * _16KPAGE + Offset));
    return NULL;
}

// Returns the number of pages associated with a EMS handle
int far pagewithhandle(int Handle, int *error)
{
   *error = TRUE;
   if (!EMS_DRIVER_OK) return 0;
     asm{
	mov AH, 4Ch
	mov DX, Handle
	int EMS_INT
	mov BX_,BX
	mov AH_,AH
       }
   if (AH_ == 0) return BX_;
   return 0;
}

//****************************************************************
// Maps a logical page to a physical page. Pass UNMAP to unmap  *
// Physical  page                                                *
//****************************************************************
void far map_un_mapems(int Handle, unsigned int LogPage, char PhyPage, int *error)
{
    *error = TRUE;
    if  (!EMS_DRIVER_OK) return;

	_AH= 0x44;
	_AL=PhyPage;
	_BX=LogPage;
	_DX=Handle;
	 geninterrupt(EMS_INT);
	*error=_AH;
}

//***************************************************************
//  This function allocates expanded memory pages from the
//   memory manager. You can use these pages to store information
//***************************************************************
void far getems_mem(int Pages, int *Handle, int *error)
{
  *error = TRUE;
  if (!EMS_DRIVER_OK) return;
     asm{
	mov   AH,43H
	mov   BX,Pages
	int   EMS_INT
	mov AH_,AH
	mov DX_,DX
       }
  *Handle = DX_;
  *error  = AH_;
}


void far used_pages(EMS_PageArray &EMSarray,int *UsedHandles,int *error )
{  int off_=FP_OFF(EMSarray);
   int seg_=FP_SEG(EMSarray);

   *error = TRUE;
   if (!EMS_DRIVER_OK) return;
       asm{
	mov AX,4Dh
	mov ES,seg_
	mov DI,off_
	int EMS_INT
	mov  AH_,AH
	mov  BX_,BX
       }
       *error = AH_;
  if (AH_== 0) *UsedHandles=BX_;
}

int far ems_isinit()
{
	_AH  = 0x3D;		     //Dos Open Function
	_AL  = 0;		     //Read only
	_DS  = FP_SEG(EMSDrvName);
	_DX  = FP_OFF(EMSDrvName);   //Skip the Length Byte
	geninterrupt(0x21);          //open file
	if (!(_FLAGS & 1 != 0) )     //if no *error then
	{
	  _BX  = _AX;                // Place Handle in BX
	  _AH = 0x44;	             // IOCTL Function
	  _AL = 0x00;	             // Info subFunction
	  geninterrupt(0x21);

	  if ( (_FLAGS & 1 != 0)) return FALSE;
	else
	   if ((_DX & 0x80) == 0) return FALSE;

	_AX = 0x4407;
	geninterrupt(0x21);

	if (_AL != 0xFF) return FALSE;

	_AH = 0x3E;
	geninterrupt(0x21);  // Close Handle
       return(TRUE);        //No error
      }
      return(FALSE);        // error
}

int   far InitEMS()
{
int   error ;
    EMS_DRIVER_OK  = FALSE;
    EMSBASEADDRESS = NULL;
    EMS_OK         = FALSE;
    MAXEMSPAGES    = 0;
    if (ems_isinit()==FALSE) return 0;

    EMS_DRIVER_OK = TRUE;
    currentemsstatus(&E_M_S_Status,&error);      // Check status, tot_AL pages
    if (error !=0) return 0;
    _AH = 0x41;		                         // Get page frame address
    geninterrupt(EMS_INT );
    if (_AH != 0) return 0;
    EMSBASEADDRESS = MK_FP(_BX,0);
    EMS_SEG        =_BX;
    EMS_OK         =TRUE;
    EMS_DRIVER_OK  =TRUE;
    return  EMS_OK;
}


int UMBAvailable(int *amount)
{
    _AH = 0x10;                              // UMB Request #
    _DX = UNMAP;                             // ask for maximum paragraphs
     XMSHandler();                           // call xmm manager
    *amount =_DX;                            // return amount og UM para
    return ( int(_BL));                      // return TRUE if mem avail
}

void * Ugetmem( size_t size)
{
    size = size << 4;                        // set size to paragraphs
    size++;                                  // possible overflow;
    _DX = size;
    _AH = 0x10;                              // UMB request #
    XMSHandler();                            // execute  handler
    if ( _AX == 0x0001 )                     // request ok if ax=1
    {
	_DX =  _BX;                          // Seg= DX
	return(void *)(MK_FP(_DX, 0x0000));  // return far pointer
    }
    return NULL;                       	     // no umem avail return NULL
}

// free upper memory block
int Ufreemem( void  * ptr )
{
    _DX = FP_SEG( ptr );
    _AH = 0x11;                             // mem return #
    XMSHandler();                           // call handler
    if ( _AX == 0x0001 )
	return( 0x00 );
	return( int( _BL ));                // return error status
}

// replaces the old new operator. is able to allocate upper memory block
void * operator new ( size_t size )
{
    void  * ptr;
    if (UMM_flag)
       {
	ptr  = Ugetmem( size );            // allocat upper memory
	if ( ptr) return  ptr ;            // return upper memory
    }
    while( (!(ptr = farmalloc(size))) && _new_handler != NULL)	_new_handler();
    return ptr;
}

// replaces the old delete operator.
void  operator delete ( void * ptr )
{
    if (UMM_flag && FP_SEG(ptr) > 0xA000)     // must be um memory
	Ufreemem( ptr );                      // so free it
    else
	farfree( ptr );                       // else it is from the far heap
}

// init upper memory manager
int INIT_UP_MEM()
{
   unsigned seg,  off;
    _AX = 0x4300;
    geninterrupt( 0x2F );
    if ( _AL == 0x80 )
    {
     _AX  = 0x4310;                         // address of multplx id
      geninterrupt(0x2F);                   // gen multiplex req
      seg  = _ES;                           // handler seg
      off  = _BX;                           // handler off
      XMSHandler= FARFPTR(MK_FP(seg, off)); // construct  XMM handler
      UMM_flag=1;                           // UMM may be avail.
    }
    return UMM_flag;
}

//***************************************
//  global variables for VTABLE MANAGER
//***************************************

typedef struct VTRec{
	char       used;   // usage flag.
	long       index;  // em_pointer reffrence index
	long       offset; // offset from first allocate vtable page
	long       orig;   // offset from first allocate vtable page
	long       length; // pages used
       }VTRec;
int             VT_forward     = TRUE;
int             VT_handle      =-1;
int             VT_bottom      =-1;
int             VT_index       =-1;
long   		VT_mem_avail   = 0;
long            VT_MemMarker   = 0;
long   	       	VT_page_used   = 0;
long   	       	VT_m_unusable  = 0;
long           	VT_largestblock= 0;
int             VTUSE_EMSPAGES = 0;
VTRec          *VT_table       = NULL;

class em_pointer{
 int      handle;
 friend  int getindex(int handle);
 friend  void far em_free(em_pointer e);        // free ems bytes on ems heap
 friend  em_pointer far em_malloc(long nbytes); // alocate nbytes on ems heap
 friend  int  far em_memset(em_pointer e, int c, long nbytes);
 friend  int  far em_copyfrom(void huge* dest, const em_pointer src, long nbytes);
 friend  int  far em_copyto  (em_pointer dest, const void huge* src, long nbytes);
 friend  int  far em_memmove (em_pointer dest, const em_pointer src, long nbytes);
 friend  em_pointer far operator+=(em_pointer e,long i);  // pointer offset incrementation
 friend  em_pointer far operator-=(em_pointer e,long i);  // pointer offset decrementation
 friend  em_pointer far operator--(em_pointer e);         // pointer offset decrementation
 friend  em_pointer far operator++(em_pointer e);         // pointer offset incrementation
 friend  int  far operator! (em_pointer e);               // NULL comparison
 friend  int  far operator==(em_pointer e1,long l);       // NULL comparison
 friend  int  far operator!=(em_pointer e1,long l);       // NULL comparison
 friend  int  far operator==(em_pointer e1,em_pointer e2);// pointer to pointer comparison
 friend  int  far operator!=(em_pointer e1,em_pointer e2);// pointer to pointer comparison
 public:
	 void far operator= (em_pointer e);               // pointer to pointer assignment
	 void far operator= (long);                       // NULL assignment
	 em_pointer(long  l=NULL);                        // NULL initalization
};


// copies bytes of conventional memory to an em_pointer that has
// allocated enough ems memory to hold the request.
// destination buffer must be large enough to hold the requested bytes.
int internal_copyto(int index, const void far* src, long nbytes)
{
  char  far *dst_ptr  =(char far*)emsdataptr(0,0);
  char huge *src_ptr  =(char huge*) src;

  ldiv_t     Pg_Off   =ldiv(VT_table[ index].orig+VT_table[ index].offset,_49KPAGE);

  int        error    =0;
  int        pages    =0;
  int        i;
  long       S_offset =0;
  long       copysize =0;

  if  (_49KPAGE-Pg_Off.rem>nbytes) copysize=nbytes; else copysize=_49KPAGE-Pg_Off.rem;
   while( nbytes >0)
      {
	pages=copysize/_16KPAGE;
	for (i=0;i<=pages;i++)
	     map_un_mapems(VT_handle, Pg_Off.quot+i, i, &error);// map pages
       _fmemcpy(&dst_ptr[Pg_Off.rem], &src_ptr[S_offset], copysize);
	for (i=0;i<=pages;i++)
	     map_un_mapems(VT_handle, UNMAP, i, &error);// map pages

	if (error) return error;
	S_offset+=copysize;                          // source offset
	nbytes-=copysize;                            // reduce nbytes remaining;
	Pg_Off.quot+=pages;                          // increment dest page
	Pg_Off.rem=0;
	if (_49KPAGE>nbytes) copysize=nbytes; else copysize=_49KPAGE;
    }
 return FALSE;
}

// copies bytes of ems memory to conventional from an em_pointer.
// destination buffer must be large enough to hold the requested bytes.
int  internal_copyfrom( void far* dest, int  index, long nbytes)
{
  char huge *dst_ptr =(char huge*) dest;
  char far *src_ptr =(char far*) emsdataptr(0,0); //use page 0,1,2 as buffer

  ldiv_t     Pg_Off   =ldiv(VT_table[ index].orig+VT_table[ index].offset,_49KPAGE);

  int        error    =0;
  int        pages    =0;
  int        i;
  long       D_offset =0;
  long       copysize =0;

  if  (_49KPAGE-Pg_Off.rem>nbytes) copysize=nbytes; else copysize=_49KPAGE-Pg_Off.rem;

    while( nbytes >0)
      {
	pages=copysize/_16KPAGE;

	for (i=0;i<=pages;i++)     map_un_mapems(VT_handle, Pg_Off.quot+i, i, &error);// map pages
       _fmemcpy(&dst_ptr[D_offset], &src_ptr[Pg_Off.rem], copysize);
	for (i=0;i<=pages;i++)     map_un_mapems(VT_handle, UNMAP, i, &error);// map pages

	if (error) return error;
	D_offset+=copysize;                          // dest offset
	nbytes-=copysize;                            // reduce nbytes remaining;
	Pg_Off.quot+=pages;                          // increment src page
	Pg_Off.rem=0;
	if (_49KPAGE>nbytes) copysize=nbytes; else copysize=_49KPAGE;
    }
 return FALSE;
}

// copies nbytes of ems memory from an em_pointer  to another em_pointer.
// the destination buffer must be large enough to hold the requested bytes.
int internal_memmove(int dest_index, int src_index, long nbytes)
{
 long bufsize=0;
 if (farcoreleft()>_49KPAGE)
     bufsize=_49KPAGE;
 else
     bufsize= farcoreleft()-1000;


 void far *temp_buffer  =(char far*)farmalloc(bufsize);

 int  error     =0;
 long copysize  =0;
 long src_off   =VT_table[src_index ].offset;// save orig offset
 long dest_off  =VT_table[dest_index].offset;// save orig offset

 while(nbytes>0)
  {
   if (bufsize>nbytes) copysize=nbytes; else copysize=bufsize;
   error=internal_copyfrom(temp_buffer, src_index,copysize); //copy bytes to buffer
   error=internal_copyto(dest_index,temp_buffer, copysize); //copy bytes from buffer
   if (error)
      {
       VT_table[dest_index].offset=dest_off; //restore original offset
       VT_table[src_index ].offset=src_off ; //restore original offset
       farfree(temp_buffer);
       return  error;
      }
   nbytes-=copysize;
   if (nbytes>0)
      {
       VT_table[dest_index].offset+=copysize;
       VT_table[src_index ].offset+=copysize;
      }
  }
  VT_table[dest_index].offset=dest_off; //restore original offset
  VT_table[src_index ].offset=src_off ; //restore original offset
  farfree(temp_buffer);
  return FALSE;
}


// copies nbytes of ems memory from an em_pointer  to another em_pointer.
// the destination buffer must be large enough to hold the requested bytes.
int far  em_memmove(em_pointer dest, const em_pointer src, long nbytes)
{
 return internal_memmove(getindex(dest.handle),getindex(src.handle),nbytes);
}

// copies bytes of conventional memory to an em_pointer that has
// allocated enough ems memory to hold the request.
// destination buffer must be large enough to hold the requested bytes.
int far em_copyto(em_pointer dest, const void huge* src, long nbytes)
{
  return internal_copyto(getindex(dest.handle),src,nbytes);
}

// copies bytes of ems memory to conventional from an em_pointer.
// destination buffer must be large enough to hold the requested bytes.
int far  em_copyfrom( void huge* dest, const em_pointer src, long nbytes)
{
  return internal_copyfrom(dest,getindex(src.handle),nbytes);
}

//memset sets the first nbytes of the e to the character c.
int far em_memset(em_pointer e, int c, long nbytes)
{
  char far *dst_ptr  =(char far*)emsdataptr(0,0);
  int        index=getindex(e.handle);
  ldiv_t     Pg_Off   =ldiv(VT_table[index ].orig+VT_table[ index].offset,_49KPAGE);

  int        i;
  int        error    =0;
  int        pages    =0;
  long       fillsize =0;

  if  (_49KPAGE-Pg_Off.rem>nbytes) fillsize=nbytes; else fillsize=_49KPAGE-Pg_Off.rem;
   while( nbytes >0)
      {
	pages=fillsize/_16KPAGE;
	for (i=0;i<=pages;i++)
	     map_un_mapems(VT_handle, Pg_Off.quot+i, i, &error);// map pages
       _fmemset(&dst_ptr[Pg_Off.rem], c, fillsize);
	for (i=0;i<=pages;i++)
	     map_un_mapems(VT_handle, UNMAP, i, &error);// map pages

	if (error) return error;
	nbytes-=fillsize;                            // reduce nbytes remaining;
	Pg_Off.quot+=pages;                          // increment dest page
	Pg_Off.rem=0;
	if (_49KPAGE>nbytes) fillsize=nbytes; else fillsize=_49KPAGE;
    }
 return FALSE;
}


// defragment the ems memory by removing dead ems bytes
int CompactMemory()
{
   long              temp_offset=0;
   int               from,to;

   if (!VT_m_unusable) return FALSE;
   VT_largestblock   =0;
   if (VT_forward)
     {
      VT_MemMarker   =VT_mem_avail;  //set new marker to bottom of ems heap
      VT_forward      =FALSE;          //set new direction
      to              =VT_bottom;
      for (from=VT_index;from>-1;from--)
	if (VT_table[from].used)
	   {
	     to--;
	     temp_offset=VT_table[from].offset;
	     VT_table[from].offset=0;      // temporarily set offset to 0
	     VT_table[to  ]       =VT_table[from];
	     VT_table[to  ].orig  =VT_MemMarker-VT_table[from].length+1;
						       // set new offset
	     internal_memmove(to,from,VT_table[from].length);
	     // move date from old location to new consecutive locaton
	     VT_table[to  ].offset=temp_offset;       //restore orig offset
	     VT_MemMarker       =VT_table[to].orig-1; //advance free space marker
	     VT_page_used+=VT_table[from].length;     //count used pages
	     if (VT_table[from].length*2 > VT_largestblock)
		 VT_largestblock=VT_table[from].length*2;// reserved area free space
	   }
      VT_index=to; // index points to last used space
      VT_m_unusable=0;
      return TRUE; // always true so I do not have to check for backward
     }

//****************************************************************
//                    backward
//****************************************************************
    VT_MemMarker   =0;  //set new marker to top of ems heap
    VT_forward      =TRUE;
    to              =-1;
    for (from=VT_index;from<VT_bottom;from++)
	if (VT_table[from].used)
	   {
	     to++;
	     temp_offset          =VT_table[from].offset;
	     VT_table[from].offset=0;         // temporarily set offset to 0
	     VT_table[to  ]=VT_table[from];
	     VT_table[to].orig=VT_MemMarker; // set new offset
	     internal_memmove(to,from,VT_table[from].length);
	     // move date from old location to new consecutive locaton
	     VT_table[to  ].offset=temp_offset;//restore orig offset
	     VT_MemMarker   +=VT_table[from].length;    //advance free space marker
	     if (VT_table[from].length*2 > VT_largestblock)
		 VT_largestblock=VT_table[from].length*2;// reserved area free space
	   }
      VT_index=to; // index points to last used space
      VT_m_unusable=0;
 return TRUE;
}

// returns the amount  of memory remaining on the ems heap that
// can be allocated with em_malloc.
long far ems_memavail()
{
  if (VT_forward) return VT_mem_avail-VT_MemMarker+VT_m_unusable-VT_largestblock;
  if (VT_MemMarker+VT_m_unusable>VT_largestblock)
      return VT_MemMarker+VT_m_unusable-VT_largestblock;
  return 0;
}

// returns the size of the largest contigious block of ems memory that
// can be allocated.  If you want a larger block and there is more ems
// memory available, the virtual pointer memory manager will try to
// defragment the memory.
long far ems_maxavail()
{
 if (VT_forward) return VT_mem_avail-VT_MemMarker-VT_largestblock;
 if (VT_MemMarker>VT_largestblock) return VT_MemMarker-VT_largestblock;
 if (VT_m_unusable>VT_largestblock) return VT_largestblock;
 return 0;
}

// allocate certain pages of ems memory and return it in an em_pointer.
// if not enough pages is available then the em_pointer returned is = NULL.
// em_pointers can be tested for null condition.
em_pointer far  em_malloc(long nbytes)
{ static long __index=0;                      // used to generate indexes

  em_pointer e;
  if (!VT_mem_avail) return e;

  int test=VT_largestblock;
  if  (nbytes+1000>VT_largestblock) test=nbytes+1000;

  if (VT_forward)
     {
      if (VT_MemMarker+test > VT_mem_avail && VT_m_unusable<test) return e;
      if (VT_index==VT_bottom-1 && VT_m_unusable<test)return e;
      if (VT_MemMarker+test >VT_mem_avail) CompactMemory(); else
      if (VT_index==VT_bottom-1) CompactMemory();
     }

  if (!VT_forward)
     {
      if (VT_MemMarker-test <0 && VT_m_unusable<test) return e;
      if (VT_index==0          && VT_m_unusable<test) return e;
      if (VT_MemMarker+test <0  ) CompactMemory(); else
      if (VT_index==0)            CompactMemory();
     }
    if (VT_forward)
       {
       VT_index++;
       VT_table[VT_index].used=TRUE;
       VT_table[VT_index].offset=VT_MemMarker;
       VT_table[VT_index].orig=VT_MemMarker;
       VT_table[VT_index].length=nbytes;
       VT_table[VT_index].index=__index++;
       VT_MemMarker+=nbytes;
       e.handle=VT_table[VT_index].index;
     }
    if (!VT_forward)
       {
       VT_index--;
       VT_MemMarker=VT_MemMarker-nbytes+1;
       VT_table[VT_index].used=TRUE;
       VT_table[VT_index].offset=VT_MemMarker;
       VT_table[VT_index].orig=VT_MemMarker;
       VT_table[VT_index].length=nbytes;
       VT_table[VT_index].index=__index++;
       e.handle=VT_table[VT_index].index;
     }
    if  (nbytes+1000>VT_largestblock) VT_largestblock=nbytes+1000;

  return e;
}

// look up the index in VT_table when given the handle of an em_pointer
// for internal use only.
int getindex(int handle)
{
  int i;
  for (i=0;i<VT_bottom;i++) if (VT_table[i].index==handle) return i;
  //printf(" runtime error 1000: ems pointer index error ");
  return -1;
}

// free the pages allocated by a em_pointer;
void far em_free(em_pointer e)
{ int i=getindex(e.handle);
  if (i>=VT_bottom || i<0) return;

  VT_m_unusable+=VT_table[i].length; //fragmented space
  VT_table[i].used=FALSE;
  VT_table[i].length=0;
}

// restore all the pages allocated to the virtual em_pointer manager
// at program shut down. internal use only.
void   free_all_memory()
{ int i=0;
 freehandle(VT_handle,&i);
}

// initalize the ems pointer virtual table. if less than 6 ems pages is
// available then there will only be NULL em_pointers returned my em_malloc
// internal use only.
int INIT_VIRT_EMM_PTRTABLE()
{
 int i;
 atexit(free_all_memory);
 currentemsstatus(&E_M_S_Status,&i); if (i) return FALSE;
 if (E_M_S_Status.UsedHandles==255)   return FALSE; // no handles left
 if (VTUSE_EMSPAGES) E_M_S_Status.UnusedPages=VTUSE_EMSPAGES;

 getems_mem(E_M_S_Status.UnusedPages, &VT_handle, &i);

 if (i) return FALSE; // error in obtaining the required pages.
 VT_bottom=2000;      // maximum table size
 VT_table =(VTRec *)farmalloc(VT_bottom* sizeof(VTRec));
 VT_mem_avail = long(E_M_S_Status.UnusedPages) * long(_16KPAGE);
 if (!VT_table)
    {
    VT_bottom=1000;   // maximum table size
    VT_table =(VTRec *)farmalloc(VT_bottom* sizeof(VTRec));
    }

 if (!VT_table)
     {
       freehandle(VT_handle,&i); // free allocated pages
       VT_bottom=-1;             // not enough std memory for buffer
       VT_mem_avail=0;
       return FALSE;
      }
  for(i=0;i<VT_bottom;i++)
       memset(&VT_table[i],0,sizeof(VT_table[i]));

  return TRUE;
}


//*******************   NULL COMPARISONS and ASSIGNMENT *******************

int far operator==(em_pointer e,long l)
{
 if (l!=NULL) return FALSE;  return (e.handle==-1);
}

int far operator!=(em_pointer e,long l)
{
 if (l!=NULL) return FALSE;  return (e.handle!=-1);
}

void far em_pointer::operator=(long l)
{ if (l!=NULL) handle=-1; }

em_pointer::em_pointer(long l)
{ handle=-1; l=l;}

//****************** pointer to pointer assignment ******************
int far operator!(em_pointer e)
{ return !(e.handle!=-1);}

em_pointer far operator+=(em_pointer e, long i)
{
  VT_table[ getindex(e.handle)].offset+=i;
  return e;
}
em_pointer far operator-=(em_pointer e, long i)
{
  VT_table[ getindex(e.handle)].offset-=i;
  return e;
}

em_pointer far operator++(em_pointer e)
{
  VT_table[ getindex(e.handle)].offset++;
  return e;
}

em_pointer far  operator--(em_pointer e)
{
  VT_table[ getindex(e.handle)].offset--;
  return e;
}

void far em_pointer::operator=(em_pointer e)
{ handle=e.handle;}

int far operator==(em_pointer e1,em_pointer e2)
{  return (e1.handle==e2.handle); }

int far operator!=(em_pointer e1,em_pointer e2)
{ return (e1.handle!=e2.handle);}

int HAS_EMS              =InitEMS();
int HAS_UPPERMEM         =INIT_UP_MEM();
int HAS_VIRTUAL_EMS_PTRS =INIT_VIRT_EMM_PTRTABLE();